#include <stdio.h>
#include <mpi.h>

#include "mpi-utils.h"

#define BUFFER_SIZE 128

enum {
  TAG_BUFFER = 1,
  TAG_LENGTH
};

int main (int argc, char * argv[]) {
  int i;
  int mpi_rank;
  int mpi_size;

  char buffer[BUFFER_SIZE];
  int length;

  MPI_Init(&argc, &argv);

  MPI_Comm_rank(MPI_COMM_WORLD, &mpi_rank);
  MPI_Comm_size(MPI_COMM_WORLD, &mpi_size);

  length = sprintf(buffer, "Hello world, I am process %d out of %d!",
		   mpi_rank, mpi_size);

  if (PROCESS_IS_ROOT(mpi_rank)) {
    puts(buffer);

    for (i = 1; i < mpi_size; i++) {
      MPI_Recv(&length, 1, MPI_INT, i, TAG_LENGTH,
	       MPI_COMM_WORLD, MPI_STATUS_IGNORE);
      MPI_Recv(buffer, length, MPI_CHAR, i, TAG_BUFFER,
	       MPI_COMM_WORLD, MPI_STATUS_IGNORE);

      puts(buffer);
    }
  } else {
    MPI_Send(&length, 1, MPI_INT, ROOT_PROCESS, TAG_LENGTH,
	     MPI_COMM_WORLD);
    MPI_Send(buffer, length, MPI_CHAR, ROOT_PROCESS, TAG_BUFFER,
	     MPI_COMM_WORLD);
  }

  FINALIZE_AND_SUCCEED;
}
